#ifndef __UNIXSEM_H
#define __UNIXSEM_H

/*
** $VER: unixsem.c 1.0 (05 Mar 95)
**
** UNIX like counting semaphores for the AMIGA
**
** (C) Copyright 1995
**     Marius Grger
**
** $HISTORY:
**
** 05 Mar 1995 : 001.000 :  created
*/

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef EXEC_SEMAPHORES_H
#include <exec/semaphores.h>
#endif

   /*
   ** PRIVATE data structure.
   ** You have _NEVER_ seen this, have you ?
   */
typedef struct
{
   struct SignalSemaphore sem_Lock;
   LONG                   sem_Count;
   struct MinList         sem_WaitingSpace;
   ULONG                  sem_SigMask;
}
CountSemaphore;

   /* specify the default exec signal to use */
#define UNIXSEM_SIGMASK SIGBREAKF_CTRL_E

   /* function call interface */
extern VOID sinit(CountSemaphore *sem, ULONG sigmask);
extern VOID sset(CountSemaphore *sem, LONG val);
extern VOID ssignal(CountSemaphore *sem);
extern VOID swait(CountSemaphore *sem);

#endif

